dofile( "data/scripts/lib/utilities.lua" )
dofile( "data/scripts/perks/perk.lua" )
dofile( "data/scripts/perks/perk_list.lua" )

function drop_random_reward( x, y, entity_id )
	-- local set_rnd = set_rnd_ or true
	local set_rnd = false
	if( set_rnd ) then
		SetRandomSeed( x, y )
	end
	
	local count = 1
	while( count > 0 ) do
		count = count - 1
		local rnd = Random(1,100)
		
		if( rnd <= 10 ) then
			-------------------------------------------------------------------
			-- Potion
			-------------------------------------------------------------------
			rnd = Random(0,100)
			if (rnd <= 98) then
				EntityLoad( "data/entities/items/pickup/potion.xml", x + 8, y - 4 + Random(-5,5) )
				EntityLoad( "data/entities/items/pickup/potion.xml", x - 8, y - 4 + Random(-5,5) )
			elseif (rnd <= 100) then
				rnd = Random(0,100)
				if( rnd <= 98 ) then
					EntityLoad( "data/entities/items/pickup/potion_secret.xml", x + Random(-10,10), y - 4 + Random(-5,5) )
				elseif( rnd <= 100 ) then
					EntityLoad( "data/entities/items/pickup/potion_random_material.xml", x + Random(-10,10), y - 4 + Random(-5,5) )
				end
			end
			
		elseif( rnd <= 35 ) then
			-------------------------------------------------------------------
			-- Random Perk
			-------------------------------------------------------------------
			local random_perk1 = perk_list[Random(1,#perk_list)]
			local random_perk2 = perk_list[Random(1,#perk_list)]
			perk_spawn( x + Random(-15,-5), y - 4 + Random(-10,10), random_perk1.id)
			perk_spawn( x + Random(5,15), y - 4 + Random(-10,10), random_perk2.id)
			
		elseif( rnd <= 55 ) then
			-------------------------------------------------------------------
			-- Random card
			-------------------------------------------------------------------
			EntityLoad( "data/entities/items/pickup/random_card.xml", x + 8, y - 4 + Random(-10,10) )
			EntityLoad( "data/entities/items/pickup/random_card.xml", x - 8, y - 4 + Random(-10,10) )
		
		elseif( rnd <= 75 ) then
			-------------------------------------------------------------------
			-- Wand
			-------------------------------------------------------------------

			rnd = Random(0,100)
			
			if( rnd <= 25 ) then
				EntityLoad( "data/entities/items/wand_level_01.xml", x + Random(-10,10), y - 4 + Random(-10,10) )
			elseif( rnd <= 50 ) then
				EntityLoad( "data/entities/items/wand_unshuffle_01.xml", x + Random(-10,10), y - 4 + Random(-10,10) )
			elseif( rnd <= 75 ) then
				EntityLoad( "data/entities/items/wand_level_02.xml", x + Random(-10,10), y - 4 + Random(-10,10) )
			elseif( rnd <= 90 ) then
				EntityLoad( "data/entities/items/wand_unshuffle_02.xml", x + Random(-10,10), y - 4 + Random(-10,10) )
			elseif( rnd <= 96 ) then
				EntityLoad( "data/entities/items/wand_level_03.xml", x + Random(-10,10), y - 4 + Random(-10,10) )
			elseif( rnd <= 98 ) then
				EntityLoad( "data/entities/items/wand_unshuffle_03.xml", x + Random(-10,10), y - 4 + Random(-10,10) )
			elseif( rnd <= 99 ) then
				EntityLoad( "data/entities/items/wand_level_04.xml", x + Random(-10,10), y - 4 + Random(-10,10) )
			elseif( rnd <= 100 ) then
				EntityLoad( "data/entities/items/wand_unshuffle_04.xml", x + Random(-10,10), y - 4 + Random(-10,10) )
			end
		elseif( rnd <= 95 ) then
			-------------------------------------------------------------------
			-- Heart(s)
			-------------------------------------------------------------------
			rnd = Random(0,100)
			
			if (rnd <= 89) then
				EntityLoad( "data/entities/items/pickup/heart.xml", x + Random(-10,10), y - 4 + Random(-10,10) )
			elseif (rnd <= 99) then
				EntityLoad( "data/entities/items/pickup/heart_better.xml", x + Random(-10,10), y - 4 + Random(-10,10) )
			else
				EntityLoad( "data/entities/items/pickup/heart_fullhp.xml", x + Random(-10,10), y - 4 + Random(-10,10) )
			end
		elseif( rnd <= 99 ) then
			-------------------------------------------------------------------
			-- exploding "dice"
			-------------------------------------------------------------------

			-- explode the random table
			-- do random reward 2 times...
			count = count + 2
		elseif( rnd <= 100 ) then
			-- explode the random table
			-- do random reward 3 times...
			count = count + 3
		end
	end
end

function drop_money( entity_item )
	
	-- 
end

function on_open( entity_item )
	local x, y = EntityGetTransform( entity_item )
	local rand_x = x
	local rand_y = y

	-- PositionSeedComponent
	local position_comp = EntityGetFirstComponent( entity_item, "PositionSeedComponent" )
	if( position_comp ) then
		rand_x = tonumber(ComponentGetValue( position_comp, "pos_x") )
		rand_y = tonumber(ComponentGetValue( position_comp, "pos_y") )
	end

	SetRandomSeed( rand_x, rand_yy )

	EntityLoad("data/entities/particles/image_emitters/chest_effect.xml", x, y)

	-- money
	-- card
	-- potion
	-- wand
	-- bunch of spiders
	-- bomb
	drop_random_reward( x, y, entity_item )
end

function item_pickup( entity_item, entity_who_picked, name )
	GamePrintImportant( "$log_chest", "" )
	-- GameTriggerMusicCue( "item" )

	--if (remove_entity == false) then
	--	EntityLoad( "data/entities/misc/chest_random_dummy.xml", x, y )
	--end

	on_open( entity_item )
	
	EntityKill( entity_item )
end

function physics_body_modified( is_destroyed )
	-- GamePrint( "A chest was broken open" )
	-- GameTriggerMusicCue( "item" )
	local entity_item = GetUpdatedEntityID()
	
	on_open( entity_item )

	edit_component( entity_item, "ItemComponent", function(comp,vars)
		EntitySetComponentIsEnabled( entity_item, comp, false )
	end)
	
	EntityKill( entity_item )
end